%# get a sample data with 0 for empty, 1 for solid
brain=load_nii('csf_MNI_1mm.nii');%

v=zeros(size(brain.img));
pos=findn(brain.img>0.9);%>0.95);
sel=randi(size(pos,1),50000,1);
for i=1:10000
    v(pos(sel(i),1),pos(sel(i),2),pos(sel(i),3))=1;
end

%# visualize the volume
hold on
p = patch( isosurface(v,0) );                 %# create isosurface patch
isonormals(v, p)                              %# compute and set normals
set(p, 'FaceColor',[0.75 0.75 0.75], 'EdgeColor','none','MarkerSize',2)   %# set surface props
daspect([1 1 1])                              %# axes aspect ratio
view(3), axis vis3d tight, box on, grid on    %# set axes props
camproj perspective                           %# use perspective projection
camlight, lighting phong, alpha(.1)           %# enable light, set transparency