function UI = RichMind( varargin )
   
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Main figure
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  if(~isempty(varargin))
      UI=varargin{1};
  end
    sz=get(0,'ScreenSize');
    lenx=1;
    leny=1;
    ox=0.5-lenx/2;  
    oy=0.5-leny/2;
    S.fh = figure('HandleVisibility','off',...
    'units','normalized',...
        'position',[ox oy lenx leny],...
        'menubar','none',...  
        'name','RichMind v1.0',...
        'numbertitle','off',...
        'Interruptible','off',...
        'BusyAction','cancel',...
        'resize','on');
     S.fh3D = [];
     S.waitbar=0;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Output panel
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    S.OUT.panel=uipanel('Parent',S.fh,...
        'units','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Title','Results',...
        'FontSize',12,...
        'FontWeight','Bold',...
        'BorderType','BeveledIn',...
         'Position',[0.47 0.07 0.5 0.89]);
       % 'Position',[0.57 0.05 0.41 0.91]);%'Position',[0.02 0.02 1-0.04 0.35]);%0.2250]);
   
%     S.OUT.ls = uicontrol('Parent',S.OUT.panel,...
%                   'style','list',...
%                  'unit','normalized',...
%                  'position',[0.02 0.9 0.95 0.5],...%[0 0.3 0.55 0.8] &changed,...%[0 0 0.7 0.95],...
%                  'min',0,'max',2,...
%                  'fontsize',10,...
%                  'FontName','FixedWidth',...
%                  'BackgroundColor','white',...
%                  'Value',[],...
%                  'String','Ready...|RichMind v1.0 Copyright (C) 2014|This program comes with ABSOLUTELY NO WARRANTY.|This is free software, distributed under the GNU General Public Licence.'); 
%              
     S.OUT.ls = uitable('Parent',S.OUT.panel,...
          'Units','normalized',...
          'position',[0.05 0.65 0.9 0.32]);
                 %'position',[0.02 0.9 0.95 0.5]);
%     S.OUT.fh =uipanel('Parent',S.OUT.panel,...             %   'Style','slider',...
%                   'Units','normalized',...
%                  'position',[0.6 0.3 0.4 0.7],...
%                  'BackgroundColor','white'); 
       S.OUT.ax = axes('Parent',S.OUT.panel,...%S.fh,...
       'units','normalized',...
            'position',[0.12,0.4,0.62,0.2],...%'position',[0.07,0.13,0.41,0.15],...&changed [0.62,0.15,0.35,0.25]
            'box','off');
        set(S.OUT.ax,'XTickLabel',[]);
        set(S.OUT.ax,'YTickLabel',[]);
           
        S.OUT.fr_ax = axes('Parent',S.OUT.panel,...%S.fh,...
       'units','normalized',...
            'position',[0.12,0.19,0.62,0.2],...%[0.55,0.13,0.41,0.15],...&changed [0.62,0.15,0.35,0.25]
            'box','off');
        set(S.OUT.fr_ax,'XTickLabel',[]);
        set(S.OUT.fr_ax,'YTickLabel',[]);
        S.OUT.cLegend=axes('Parent',S.OUT.panel,...%S.fh,...
       'units','normalized',...%[0.12,0.4,0.62,0.2]
            'position',[0.76,0.19,0.2,0.41],...%[0.55,0.13,0.41,0.15],...&changed [0.62,0.15,0.35,0.25]
            'box','off', 'XTickLabel',[],'YTickLabel',[],'xcolor','w','ycolor','w');
        
         


   %     bar([1,2,3,4],'parent',S.OUT.ax);
      
        %rectangle( 'Parent',S.OUT.ax,'FaceColor','r');
    if exist('selection_callback','var')
         if ~iscell(selection_callback)
           selection_callback = {selection_callback};
         end
    else
         selection_callback = [];
    end
    %Remove highlighting from listbox
  %  set(S.OUT.ls,'Callback',{@onResSelected,S});%S   
    
      set(S.OUT.ls,'cellSelectionCallback',{@onResSelected,S});%S             

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Data panel
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    dataPanelControlHight=0.12;
    S.DATA.panel=uipanel('Parent',S.fh,...
        'units','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Title','Data',...
        'FontSize',12,...
        'FontWeight','Bold',...
        'BorderType','BeveledIn',...
         'Position',[0.02 0.56,0.44 0.4]);
      %  'Position',[0.02 0.56,0.53 0.4]);
        
    %0.2250]);
    
    origin_matrices=0.8;
    types={'*.nii;*.img;*.mat;*.txt','NIFTI file (*.nii or *.img), MAT-files (*.mat), Text Files (*.txt)'};
  
    S.DATA.GOIs.text=uicontrol('Parent',S.DATA.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[0.03 origin_matrices-0.05 0.3 (dataPanelControlHight-0.015)*2],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Sets of interest');
    set(S.DATA.GOIs.text,'string',{'  Sets of';'  interest'});
    
    
    S.DATA.GOIs.edit=uicontrol('Parent',S.DATA.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[0.3 origin_matrices 0.62 dataPanelControlHight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','');

    S.DATA.GOIs.button=uicontrol('Parent',S.DATA.panel,...
        'style','pushbutton',...
        'unit','normalized',...
        'position',[0.6+0.32 origin_matrices 0.05 dataPanelControlHight],...
        'CData',iconRead(['icons',filesep,'opendoc.mat']),...
        'callback',{@load_file,S.DATA.GOIs.edit,types,true});
    

    origin_node_coor=0.55;
    S.DATA.node_coor.text=uicontrol('Parent',S.DATA.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[0.02 origin_node_coor 0.3 dataPanelControlHight-0.015],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String',' Coordinates');
    
    S.DATA.node_coor.edit=uicontrol('Parent',S.DATA.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[0.3 origin_node_coor 0.62 dataPanelControlHight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','');
    
    S.DATA.node_coor.button=uicontrol('Parent',S.DATA.panel,...
        'style','pushbutton',...
        'unit','normalized',...
        'position',[0.6+0.32 origin_node_coor 0.05 dataPanelControlHight],...
        'CData',iconRead(['icons',filesep,'opendoc.mat']),...
        'callback',{@load_file,S.DATA.node_coor.edit,types,false});
   
    origin_node_labels=0.3;
    S.DATA.node_label.text=uicontrol('Parent',S.DATA.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[0.03 origin_node_labels 0.3 dataPanelControlHight-0.015],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Annotations');
    
    S.DATA.node_label.edit=uicontrol('Parent',S.DATA.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[0.3 origin_node_labels 0.62 dataPanelControlHight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','');
    S.DATA.node_labels.button=uicontrol('Parent',S.DATA.panel,...
        'style','pushbutton',...
        'unit','normalized',...
        'position',[0.6+0.32 origin_node_labels 0.05 dataPanelControlHight],...
        'CData',iconRead(['icons',filesep,'opendoc.mat']),...
        'callback',{@load_file,S.DATA.node_label.edit,types,true});
    %['*.nii;*.img;*.mat;*.txt','NIFTI file (*.nii or *.img), MAT-files (*.mat), Text Files (*.txt)']
    origin_labels_conv=0.05;
    S.DATA.label_conv.text=uicontrol('Parent',S.DATA.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[0.03 origin_labels_conv-0.05 0.3 (dataPanelControlHight-0.015)*2],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Annotation labels');
    set(S.DATA.label_conv.text, 'String',{'Annotation';'  labels'});
   % 'position',[x start y start x width y width ],...
    S.DATA.label_conv.edit=uicontrol('Parent',S.DATA.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[0.3 origin_labels_conv 0.62 dataPanelControlHight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','');
    
    S.DATA.label_conv.button=uicontrol('Parent',S.DATA.panel,...
        'style','pushbutton',...
        'unit','normalized',...
        'position',[0.6+0.32 origin_labels_conv 0.05 dataPanelControlHight],...
        'CData',iconRead(['icons',filesep,'opendoc.mat']),...
        'callback',{@load_file,S.DATA.label_conv.edit, {'*.txt' ,'Tab delimited text file (*.txt)'}});
        %'callback',{@load_file,S.DATA.label_conv.edit, {'*.xls;*.xlsx','Excel file (*.xls or *.xlsx)'}});
        %{'*.xls;*.xlsx;*.txt','Text file (*.txt), Excel file (*.xls or *.xlsx)'}});
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Analysis settings panel
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      analysisPanelControlHeight=0.12;
      leftMargins=0.03;
    S.ANAL.panel=uipanel('Parent',S.fh,...
        'units','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Title','Analysis Settings',...
        'FontSize',12,...
        'FontWeight','Bold',...
        'BorderType','BeveledIn',...
         'Position',[leftMargins 0.15 0.44 0.4]);%&changed[0.02 0.45 1-0.04 0.2250]);  
       % 'Position',[0.02 0.53 1-0.04 0.16]);%&changed[0.02 0.45 1-0.04 0.2250]);  

    %start=0.1;
    origin_overlap=0.4;
     origin_sig=0.7; 
    S.ANAL.overlap.text=uicontrol('Parent',S.ANAL.panel,...
        'style','text',...  
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[leftMargins+ 0.51 origin_sig-0.01 0.3 analysisPanelControlHeight ],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','%Overlap:');
    
    
    S.ANAL.overlap.edit=uicontrol('Parent',S.ANAL.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[leftMargins+0.72 origin_sig 0.12 analysisPanelControlHeight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','5');
    origin_sig=0.7; 
     
      origin_type=origin_overlap;
    S.ANAL.type.text=uicontrol('Parent',S.ANAL.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[leftMargins origin_sig-0.01 0.3 analysisPanelControlHeight ],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Analyze:');
   
    S.ANAL.type.edit=uicontrol('Parent',S.ANAL.panel,...
        'style','popupmenu',...
        'unit','normalized',...
        'position',[leftMargins+0.17 origin_sig 0.3 analysisPanelControlHeight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Nodes|Connections'); 
  
 
    S.ANAL.method.text=uicontrol('Parent',S.ANAL.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[leftMargins origin_overlap+0.02 0.3 analysisPanelControlHeight],... 
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Method:');
    
    
    
    S.ANAL.method.edit=uicontrol('Parent',S.ANAL.panel,...
        'style','popupmenu',...
        'unit','normalized',...
        'position',[leftMargins+0.17 origin_type+0.05 0.3 analysisPanelControlHeight-0.01 ],...
        'fontsize',12,...
        'Enable','off',...
        'HorizontalAlignment','left',...
        'String','HG test|Connection permutations|Label permutations');
          
        
  S.ANAL.perms.text=uicontrol('Parent',S.ANAL.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[leftMargins+ 0.51 origin_type+0.02 0.3 analysisPanelControlHeight ],... 
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','#Permutations:');
    
    
    
    S.ANAL.perms.edit=uicontrol('Parent',S.ANAL.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[leftMargins+0.8 origin_overlap+0.02 0.15 analysisPanelControlHeight ],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'Enable','off',...
        'String','1000');
    set( S.ANAL.type.edit, 'Callback',{@typeEditCallback,S});

    
   set( S.ANAL.method.edit, 'Callback',{@methodEditCallback,S});
    S.ANAL.alpha.text=uicontrol('Parent',S.ANAL.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[leftMargins 0.15 0.3 analysisPanelControlHeight],... %[0.7 origin_sig-0.01 0.3 analysisPanelControlHeight ],... 
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Significance:');
    

    S.ANAL.alpha.edit=uicontrol('Parent',S.ANAL.panel,...
        'style','edit',...
        'unit','normalized',...
        'position',[leftMargins+0.25 0.15 0.12 analysisPanelControlHeight],...%[0.88 origin_sig 0.1 analysisPanelControlHeight],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','0.05');
    
   
  
    S.ANAL.mtc.text=uicontrol('Parent',S.ANAL.panel,...
        'style','text',...
        'unit','normalized',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'position',[leftMargins+ 0.51 0.13 0.3 analysisPanelControlHeight ],...%[0.64 origin_overlap+0.01 0.3 analysisPanelControlHeight ],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Correction:');
    
    S.ANAL.mtc.edit=uicontrol('Parent',S.ANAL.panel,...
        'style','popupmenu',...
        'unit','normalized',...
        'position',[0.76 0.15 0.2 analysisPanelControlHeight-0.01 ],...
        'fontsize',12,...
        'HorizontalAlignment','left',...
        'String','Bonferroni|FDR|None',...
        'value',2);
    
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %RUN BUTTON
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    S.ENRCH.run=uicontrol('Parent',S.fh,...%ANAL.panel,...
        'style','pushbutton',...
        'unit','normalized',...
        'position',[0.2 0.07 0.1 0.05 ],...%[0.83 0.3 0.13 0.6 ],...%[0.4 0 0.2 0.2 ],... &changed%[0.79 0.18 0.175 0.63 ],...
        'fontsize',15,...
        'Enable','on',...
        'HorizontalAlignment','left',...
        'BackgroundColor',[0.9,0.9,0.9],...
        'String','Go>>');       
     
   
    
    
 %Set callback for run button 
   
    S.toolbar=uitoolbar(S.fh);     
     [X map] = imread('icons\save_file.gif');
    icon = ind2rgb(X,map);

    S.button(1)=uipushtool(S.toolbar,...
           'TooltipString','Export results',...
        'CData',icon,'Enable','off');
    S.res=[];
   set(S.button(1),'ClickedCallback',{@saveCurrResults,S});
    set(S.ENRCH.run,'callback',{@get_ui,S}); 
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Callback for file open
%Load file and put path and file into edit box 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function load_file(varargin)
    h_edit=varargin{3};
    
   currPath=get(h_edit,'String');
    if(length(varargin)>3)
        types=varargin{4};
    else
        types={'*.mat;*.txt','MAT-files (*.mat), Text Files (*.txt)'};
    end
     multFiles=false;
    if(length(varargin)>4)
        multFiles=varargin{5};
    end 
    if(multFiles)
        [filename,pathname]=uigetfile(types,'Select files',currPath,'MultiSelect','on');
        strVal=[];
       
        if(~iscell(filename)&& sum(filename)~=0)  
            filename=cellstr(filename);
        end
        if(iscell(filename))
            for f=1:length(filename)
                strVal=[strVal pathname filename{f} ';'];
            end
        end
         set(h_edit,'string',strVal); 
   %     strVal=substring(strVal,1,length(strVal)-1);
    else
        [filename,pathname]=uigetfile(types,'Select file',currPath);
        if(sum(filename)~=0)
         set(h_edit,'string',[pathname,filename]); 
        end
    end
%     tmp=1;
%     try 
%         tmp = all(filename==0) && all(pathname==0); 
%     catch exception
%         pause=1;
%     end
%     if tmp 
%     else
 %       set(h_edit,'string',[pathname,filename]); 
 %   end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function get_ui(varargin)

     S=varargin{3}; 
 %  set(S.OUT.ls,'string' ,'Calculating...');
    %Reset all colors to black
%     set(S.DATA.matrices.text,'ForegroundColor','black');
%     set(S.STATS.design.text,'ForegroundColor','black');
%     set(S.STATS.contrast.text,'ForegroundColor','black');
%     set(S.STATS.thresh.text,'ForegroundColor','black');
%     set(S.STATS.test.text,'ForegroundColor','black');
%     set(S.ADV.perms.text,'ForegroundColor','black');
%     set(S.ADV.alpha.text,'ForegroundColor','black');
%     set(S.ADV.size.text,'ForegroundColor','black');
%     set(S.DATA.node_coor.text,'ForegroundColor','black');
%     set(S.ADV.exchange.text,'ForegroundColor','black');
%     set(S.DATA.node_label.text,'ForegroundColor','black');
% 
     UI.DATA.GOIsF=get(S.DATA.GOIs.edit,'string');
     UI.DATA.node_coorF=get(S.DATA.node_coor.edit,'string');
     UI.DATA.node_annotsF=get(S.DATA.node_label.edit,'string');
     UI.DATA.node_annotsConvF=get(S.DATA.label_conv.edit,'string');
     UI.ANAL.mtc=get(S.ANAL.mtc.edit,'value');  
     UI.ANAL.alpha=str2num(get(S.ANAL.alpha.edit,'string'));%add test if numeric
     if(isempty(UI.ANAL.alpha) || UI.ANAL.alpha<0 || UI.ANAL.alpha>1)
         msgbox('Illegal significance value (expecting a value between 0 and 1)');
         return;
     end
     UI.ANAL.method=get(S.ANAL.method.edit,'value');
     UI.ANAL.perms=str2num(get(S.ANAL.perms.edit,'string'));
     if(UI.ANAL.method~=1)%If method is not HG
        if(isempty(UI.ANAL.perms) || UI.ANAL.perms<100 || UI.ANAL.alpha>500000)
              msgbox('Illegal permutations value (expecting a value between 100 and 500000)');
             return;
        end
     end
     UI.ANAL.type=get(S.ANAL.type.edit,'value');
     UI.ANAL.overlap=str2num(get(S.ANAL.overlap.edit,'string')); %add test if numeric 
     if(isempty(UI.ANAL.overlap) || UI.ANAL.overlap<0 || UI.ANAL.overlap>100)
         msgbox('Illegal overlap value (expecting a value between 0 and 100)');
         return;
     end
     UI.DATA.label_conv=get(S.DATA.label_conv.edit,'string');
    
%     %Save UI 
%     save('history.mat','UI')
    
   %set(S.ENRCH.run,'Enable','off'); 
    %%%%%%%%%%%%
    %Run RichMind
   cla(S.OUT.fr_ax,'reset');
   cla(S.OUT.ax,'reset');
   cla(S.OUT.cLegend);
    S.waitbar = waitbar(0,'Calculating,please wait...'); 
  %  h= msgbox('Calculating,please wait...');
 % try
    EnrchRun(UI,S,S.waitbar);
  %catch exception
   %   msgbox(exception.message);
    
 % end
  
    delete(S.waitbar);
  
    %%%%%%%%%%%%
    set(S.ENRCH.run,'Enable','on');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function EnrchRun(UI,S,h)
%set(S.OUT.ls,'Value',1);
set(S.OUT.ls,'Data',[]);
    [~,~,ext]=fileparts(UI.DATA.node_coorF);
    if(~isempty(strfind(ext,'mat')))
        MNICoords=readNumFromMatlabFile(UI.DATA.node_coorF);
       % [MNICoords,~,~]=xlsread(UI.DATA.node_coorF);
    else if(~isempty(strfind(ext,'nii')) ||~isempty(strfind(ext,'img')) ||~isempty(strfind(ext,'hdr')))
            bgMask=load_nii(UI.DATA.node_coorF);
            positions = findn(bgMask.img);
            origin=bgMask.hdr.hist.originator(1:3);
            vs=bgMask.hdr.dime.pixdim(2);       
            [x y z ~] = mni2orFROMxyz(positions(:,1), positions(:,2), positions(:,3),vs,'xyz',origin);
         
            x=round(x);
            y=round(y);
            z=round(z);
            MNICoords=[x,y,z];
        else
            MNICoords=dlmread(UI.DATA.node_coorF);
        end
    end
    
    [~,~,ext]=fileparts(UI.DATA.GOIsF);
    if(~isempty(strfind(ext,'mat')))
        groups=readNumFromMatlabFile(UI.DATA.GOIsF);
       % [MNICoords,~,~]=xlsread(UI.DATA.node_coorF);
    else% if(~isempty(strfind(ext,'nii')) ||~isempty(strfind(ext,'img')) ||~isempty(strfind(ext,'hdr')))
       groups=loadBrainMapsFile(UI.DATA.GOIsF,MNICoords);
     % groups=dlmread(UI.DATA.GOIsF);
    end
    minRep = UI.ANAL.overlap;
    threshPval = UI.ANAL.alpha;
    correctionType='none';
    if(UI.ANAL.mtc == 1)
        correctionType='bonf';
    else if(UI.ANAL.mtc == 2)
        correctionType='fdr';
        end
    end
 
    populationSize = size(MNICoords,1);
    %[~,~,ext]=fileparts(UI.DATA.node_annotsF);
    annots=loadBrainMapsFile(UI.DATA.node_annotsF,MNICoords);
    annotsConv=loadAnnotConvFile(UI.DATA.node_annotsConvF);
    waitbar(0.2,S.waitbar);
    
    if(UI.ANAL.type == 1) 
        if(size(groups,2)>2)
            msgbox('Unexpected node groups file format');
            return;
        end
        res  = nodesEnrichment( groups,annots,minRep,threshPval,correctionType,populationSize ,h,false);%true for only considering annotated nodes
    else
        if(size(groups,2)<3)
            msgbox('Unexpected connection groups file format');
            return;
        end
        if(UI.ANAL.method == 1)%HG test   
            res = pairedEnrichment( groups,annots,minRep,threshPval,correctionType,populationSize,h );
        else
            perms=UI.ANAL.perms; 
            if(UI.ANAL.method == 2)%connection permutations (MCMC)
                 res = pairedEnrichmentPerms( groups,annots,minRep,threshPval,correctionType,populationSize,perms,2,h );
            else%Label permutations
                res = pairedEnrichmentPerms( groups,annots,minRep,threshPval,correctionType,populationSize,perms,1,h );
            end
        end  
    end
    waitbar(0.9,S.waitbar)
    
    %Display results in S
    annotsNum=length(unique(annots(:,2)));
    colors=distinguishable_colors(annotsNum);
   % colors=yeuCols;
    if(isempty(res))
     % set(S.OUT.ls,'string',{'No significant results found'});  
     msgbox('No significant results found');
    else
        S.res=res;
        %save('res.mat','res');
        %set(S.OUT.ls,'string',getResAsStrs(res, annotsConv));
        data=getResAsTable(res, annotsConv);
        rows=size(data,1);
        addition=cell(rows,1);
        for a=1:rows
            addition{a}='Click to view network';
        end
        data=[data,addition];
        set(S.OUT.ls,'Data',data);
        set(S.OUT.ls,'ColumnName',{'Set','Annotation','Corrected pValue','Frequency Ratio','Represntation Size','Network View'});
       
        pvals=[];
        frs=[];
        paired=(UI.ANAL.type ~= 1);
        for r=1:length(res)
           
            %annots{r}={mat2str(res(r).annot)};
            if(paired)
                pvals=[pvals;res(r).p,res(r).p];
             frs=[frs;res(r).freqFact,res(r).freqFact];
            else
                 pvals=[pvals,res(r).p];
                 frs=[frs;res(r).freqFact];
            end
        end
        minPval=power(10,-50);
        pvals=max(pvals,minPval);
        vals4bar=-log10(pvals);
        bh=bar(vals4bar,'parent',S.OUT.ax,'faceColor','w','edgeColor','w');
        
        fr_bh=bar(frs,'parent',S.OUT.fr_ax,'faceColor','w','edgeColor','w');
        %legend(fr_bh);
        xTickLabels=getResAsShortStrs(res,annotsConv);
%         for r=1:length(res)
%         xTickLabels=[xTickLabels, num2cell(res(r).set)];
%         end
      %  set(S.OUT.ax,'XTickLabel',xTickLabels);
          set(get(S.OUT.ax,'Title'),'String','Level of significance');
         set(S.OUT.fr_ax,'XTickLabel',xTickLabels);
      %   xlabel(S.OUT.fr_ax,'SOI');
%          %  set(get(S.OUT.fr_ax,'Title'),'String','Frequency ratio');
%         %rotateXLabels(S.OUT.ax,45);
          rotateXLabels(S.OUT.fr_ax,45);
          
        x=get(bh,'Xdata');
        y=get(bh,'Ydata');
        w=get(bh,'BarWidth');
         if(~isnumeric(x))
            x=cell2mat(x);
        end
         if(~isnumeric(y))
            y=cell2mat(y);
         end
        if(~isnumeric(w))
            w=cell2mat(w);
        end
       allAnnots=unique(annots(:,2));
      selAnnots=[];
        for r=1:length(res)
            if(paired)
                annotInd1=find(allAnnots==res(r).annot(1));
                annotInd2=find(allAnnots==res(r).annot(2));
                c1=colors(annotInd1,:);%res(r).annot(1),:);
                c2=colors(annotInd2,:);%res(r).annot(2),:);
              %  rectangle('Parent',S.OUT.ax,'Position',[x(1,r)-w(1)/3,0,w(1)/3,y(1,r)],'FaceColor',c1,'EdgeColor','k');
              if(y(2,r)>0 && w(1)>0)
                   rectangle('Parent',S.OUT.ax,'Position',[x(1,r),0,w(1)/3,y(1,r)],'FaceColor',c2,'EdgeColor','k');
                   rectangle('Parent',S.OUT.ax,'Position',[x(2,r)-w(2)/3,0,w(2)/3,y(2,r)],'FaceColor',c1,'EdgeColor','k');
                   selAnnots=[selAnnots annotInd1 annotInd2];
              end
            %   rectangle('Parent',S.OUT.ax,'Position',[x(2,r),0,x(2,r)-x(1,r),y(2,r)],'FaceColor',c2,'EdgeColor','k');
            else
                rmPos=find(allAnnots==0);
                if(rmPos>0)
                    allAnnots(rmPos)=[];
                end
                annotInd=find(allAnnots==res(r).annot);
                 c=colors(annotInd,:);%res(r).annot,:);
                 if(y(r)==0)
                     continue;
                 end
                 if(w>0 && y(r)>0)
                    rectangle('Parent',S.OUT.ax,'Position',[x(r),0.1,w/3,y(r)],'FaceColor',c,'EdgeColor','k');
                    selAnnots=[selAnnots annotInd];
                 end
            end
            
        end
        selAnnots=unique(selAnnots);
        if(length(selAnnots)>9)
            selAnnots=selAnnots(1:9);
        end
        cla(S.OUT.cLegend);
        legendContentSize=20;
        for i=1:length(selAnnots)
            rectRow=i;%floor(i/3)+1;
%             rectCol=mod(i,3);
%             if(rectCol==0)
%                 rectCol=3;
%             end
            rectW=0.001;%0.0005;
            rectH=0.005;%0.0005;
            %labelW=0.2;
            %totW=rectW+labelW
            vSpace=0.004;
            xPos=0.5;%+(rectCol-1)*totW
            yPos=(1-(rectH+vSpace)*rectRow)+0.2;
            rectangle('Parent',S.OUT.cLegend,'Position',[xPos,yPos,rectW,rectH],'FaceColor',colors(selAnnots(i),:),'EdgeColor','k');
            label='';
            if(isempty(annotsConv))
                label=num2str(selAnnots(i));
            else
                label=annotsConv{selAnnots(i),2};
            end
            text(xPos+rectW+0.0005,yPos+0.0015,label,'fontSize',8,'Visible','on','Parent',S.OUT.cLegend);%'Parent',S.OUT.cLegend); 
        end
        if(length(selAnnots)<legendContentSize)
             for i=length(selAnnots)+1:legendContentSize
              rectRow=i;%floor(i/3)+1;
            rectW=0.001;%0.0005;
            rectH=0.005;%0.0005;
            %labelW=0.2;
            %totW=rectW+labelW
            vSpace=0.004;
            xPos=0.5;%+(rectCol-1)*totW
            yPos=(1-(rectH+vSpace)*rectRow)+0.2;
            rectangle('Parent',S.OUT.cLegend,'Position',[xPos,yPos,rectW,rectH],'FaceColor','w','EdgeColor','w');
            text(xPos+rectW+0.0005,yPos+0.0015,'','fontSize',8,'Visible','on','Parent',S.OUT.cLegend);   
             end
            
        end
         x=get(fr_bh,'Xdata');
        y=get(fr_bh,'Ydata');
        w=get(fr_bh,'BarWidth');
        if(~isnumeric(x))
            x=cell2mat(x);
        end
         if(~isnumeric(y))
            y=cell2mat(y);
         end
        if(~isnumeric(w))
            w=cell2mat(w);
        end
        
        for r=1:length(res)
            if(paired)
                annotInd1=find(allAnnots==res(r).annot(1));
                annotInd2=find(allAnnots==res(r).annot(2));
                
                c1=colors(annotInd1,:);%res(r).annot(1),:);
                c2=colors(annotInd2,:);%res(r).annot(2),:);
                if(w(1)>0 && y(1,r)>0)
                    rectangle('Parent',S.OUT.fr_ax,'Position',[x(1,r)-w(1)/3,0,w(1)/3,y(1,r)],'FaceColor',c1,'EdgeColor','k');
                    rectangle('Parent',S.OUT.fr_ax,'Position',[x(2,r),0,w(2)/3,y(2,r)],'FaceColor',c2,'EdgeColor','k');
                end
            else
                annotInd=find(allAnnots==res(r).annot);
                
                 c=colors(annotInd,:);%res(r).annot,:);
                 if(w>0 && y(r)>0)
                    rectangle('Parent',S.OUT.fr_ax,'Position',[x(r),0.1,w/3,y(r)],'FaceColor',c,'EdgeColor','k');
                 end
            end
            
        end
      
       % S.OUT.cbar = colorbar( 'peer', S.OUT.fr_ax); 
        %set(S.OUT.ax,'XTicksLabelStyle','Vertical');
        %rotateticklabel(S.OUT.ax,45);
     %   set(S.OUT.ax,'YLabel','String','-log(pValue)');
       set(get(S.OUT.ax,'YLabel'),'String','-log(pValue)')
       set(get(S.OUT.fr_ax,'YLabel'),'String','Frequency ratio')
        for bh_ind=1:length(bh)
            bh_i=bh(bh_ind);
        end
      %  colormap(colors);
        %colors
    end
      set(S.OUT.ls,'CellSelectionCallback',{@onResSelected,res,MNICoords,annots,colors,annotsConv});%S   
  
    pause=res;
   set(S.button(1),'Enable','on');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function methodEditCallback(hObject,eventdata,S)
    index_selected=get(hObject,'Value');
    if(index_selected==1)
        set(S.ANAL.perms.edit,'Enable','off');
    else
       
        set(S.ANAL.perms.edit,'Enable','on');
        
     
    end
end

function typeEditCallback(hObject,eventdata,S)
    index_selected=get(hObject,'Value');
    if(index_selected==1)%Type is nodes
        set(S.ANAL.method.edit,'Value',1);%select HG method
        set(S.ANAL.method.edit,'Enable','off');
        set(S.ANAL.perms.edit,'Enable','off');
    else
        set(S.ANAL.method.edit,'Enable','on');
    end
end
%%%%%%%%%%%%%%
function resStrs=getResAsShortStrs(res, annotConv)
resStrs=cell(1,length(res));  

    for i=1:length(res)
        
       
        if(length(res(i).annot)>1)
            if(~isempty(annotConv))
                pos1=find(cell2mat(annotConv(:,1))==res(i).annot(1));
                pos2=find(cell2mat(annotConv(:,1))==res(i).annot(2));
                annotStr =   [annotConv{pos1,2} '-' annotConv{pos2,2}]; 
            else
                annotStr =   [num2str(res(i).annot(1)) '-' num2str(res(i).annot(2))]; 
            end
        else
            if(~isempty(annotConv))  
                if(res(i).annot==8)
                    holdIt=1;
                end
                pos=find(cell2mat(annotConv(:,1))==res(i).annot);
                annotStr =   annotConv{pos,2}; 
            else
                annotStr=num2str(res(i).annot);
            end
        end
        str_i=[annotStr '; set ' num2str(res(i).set)];
        resStrs{i}=[str_i];
    end

end


%%%%%%%%%%%%%%%%%%5555
function resStr=getResAsStrs(res, annotConv)
resStr={'Results:'};  

    for i=1:length(res)
        
       
        if(length(res(i).annot)>1)
            if(~isempty(annotConv))
                pos1=find(cell2mat(annotConv(:,1))==res(i).annot(1));
                pos2=find(cell2mat(annotConv(:,1))==res(i).annot(2));
                annotStr =   [annotConv{pos1,2} '-' annotConv{pos2,2}]; 
            else
                annotStr =   [num2str(res(i).annot(1)) '-' num2str(res(i).annot(2))]; 
            end
        else
            if(~isempty(annotConv))
                pos=find(cell2mat(annotConv(:,1))==res(i).annot);
                if(pos<1)
                    annotStr=''; 
                else
                    annotStr =   annotConv{pos,2}; 
                end
            else
                annotStr=num2str(res(i).annot);
            end
        end
        intsctLen=size(res(i).intersec);%,1);
        intsctLen=intsctLen(1);
        intsctStr=num2str(intsctLen);
        intscrTitle='# nodes=';
        if(length(res(i).intersec(1,:))>1)
            intscrTitle='# connections=';
        end
%         for j=1:intsctLen
%             elem_j=res(i).intersec(j,:);
%             if(j>1)
%                 intsctStr=[intsctStr,','];
%                
%             end
%             intsctStr=[intsctStr, num2str(elem_j(1))];
%             if(length(elem_j)>1)
%                  intscrTitle='connections=';
%                 intsctStr=[intsctStr,'-' num2str(elem_j(2))];
%             end
%         
%         end
        str_i=['set=' num2str(res(i).set) '  annot=' annotStr '  pval=' num2str(res(i).correctedP) '  freq ratio=' num2str(res(i).freqFact) '  ' intscrTitle intsctStr];
        resStr=[resStr,str_i];
    end
end
%*************************************************
function resTabRes=getResAsTable(res, annotConv)
resTabRes = cell(length(res),5);

    for i=1:length(res)
        if(length(res(i).annot)>1)
            if(~isempty(annotConv))
                pos1=find(cell2mat(annotConv(:,1))==res(i).annot(1));
                pos2=find(cell2mat(annotConv(:,1))==res(i).annot(2));
                annotStr =   [annotConv{pos1,2} '-' annotConv{pos2,2}]; 
            else
                annotStr =   [num2str(res(i).annot(1)) '-' num2str(res(i).annot(2))]; 
            end
        else
            if(~isempty(annotConv))
                pos=find(cell2mat(annotConv(:,1))==res(i).annot);
                if(isempty(pos))
                    annotStr=''; 
                else
                    annotStr =   annotConv{pos,2}; 
                end
            else
                annotStr=num2str(res(i).annot);
            end
        end
        
        intsctLen=size(res(i).intersec);%,1);
        intsctLen=intsctLen(1);
       % intsctStr=num2str(intsctLen);
       % intscrTitle='# nodes=';
       % if(length(res(i).intersec(1,:))>1)
       %     intscrTitle='# connections=';
       % end
        resTabRes{i,1}=res(i).set;
        resTabRes{i,2}=annotStr;
        resTabRes{i,3}=res(i).correctedP;
        resTabRes{i,4}=res(i).freqFact;
        resTabRes{i,5}=intsctLen;
        
        %str_i=['set=' num2str(res(i).set) '  annot=' annotStr '  pval=' num2str(res(i).correctedP) '  freq ratio=' num2str(res(i).freqFact) '  ' intscrTitle intsctStr];
        %resStr=[resStr,str_i];
    end
end






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Reding tab delimited matrices from matlab file into a known variable;
    function loaded=readNumFromMatlabFile(filePath)
        s=load(filePath);
        sFields = fieldnames(s);
        loaded = getfield(s, sFields{1});
    end
    
    
    
%loading annotation labels
function annotConv=loadAnnotConvFile(filePath)
annotConv={};
[~,~,ext]=fileparts(filePath);  
xls=(strfind(ext,'.xls')>0);
txt=(strfind(ext,'.txt')>0);
if(xls)
    [~,~,annotConv]=xlsread(filePath);
 else %if(txt)
%     [~,~,readTable]=tblread(filePath,' ');
     annotConv=table2cell(readtable(filePath,'HeaderLines',0,'Delimiter','\t'));%Expects header line
     %     annotConv(:,1)=num2cell(str2num(readTable(:,1)));
%     annotConv(:,2)=cellstr(readTable(:,2));
%    end
end



end
    
%Loading all types of node annotation files
function brainMaps=loadBrainMapsFile(filePath,allCoords)
expression = ';';
allPaths = regexp(filePath,expression,'split');
brainMaps=[];
for p=1:length(allPaths)%-1
    [~,~,ext]=fileparts(allPaths{p});
    txt=strcmp(ext,'.txt');
    if(txt)
     %annots=dlmread(filePath);
     brainMaps=[brainMaps;dlmread(allPaths{p})];
     %return;
     continue;
    end
    img=strcmp(ext,'.img')||strcmp(ext,'.hdr')||strcmp(ext,'.nii');
    if(img)  
         map=load_nii(allPaths{p});
         origin=map.hdr.hist.originator(1:3);
         vs=map.hdr.dime.pixdim(2);
         nodes=size(allCoords,1);
         maps_p=[];%zeros(nodes,2);
         skipped=0;
%          vals=unique(map.img(:));
%          vals(find(vals==0))=[];
%          for v=1:vals
%              
%          end
         for i=1:nodes
             mniPos=allCoords(i,:);
            [x y z ~] = mni2orFROMxyz(mniPos(1), mniPos(2), mniPos(3),vs,'mni',origin);
        
            x=round(x);
            y=round(y);
            z=round(z);
       
            if(x<1 || x>size(map.img,1) || y<1 || y>size(map.img,2) || z<1 ||z>size(map.img,3))
             continue;
             skipped=skipped+1;
            end
            val=map.img(x,y,z);
            if(val>0)
                maps_p=[maps_p;i,val];
            end
           
       
        
         end  
          brainMaps=[brainMaps;maps_p];  
    %return;
    end
   
end
    
end

%***************************************************************
function saveCurrResults(varargin)
S=varargin{3};

dirPath=uigetdir('','Save results in ');
if(dirPath==0)
    return;
end
try
%saveas(S.fh,[dirPath,'\mainView.png']);
%saveas(S.OUT.ax,[dirPath,'\sigBars.png']);
%saveas(S.OUT.fr_ax,[dirPath,'\sigBars.png']);
% set  annot  pVal  freqRat  numReps reps
iptFile=fopen([dirPath,'\analysisIpt.txt'],'w');
goisF=get(S.DATA.GOIs.edit,'string');
goisF = strrep(goisF, '\', '/');
node_coorF=get(S.DATA.node_coor.edit,'string');
node_coorF = strrep(node_coorF, '\', '/');
node_annotsF=get(S.DATA.node_label.edit,'string');
node_annotsF = strrep(node_annotsF, '\', '/');

node_annotsConvF=get(S.DATA.label_conv.edit,'string');
node_annotsConvF = strrep(node_annotsConvF, '\', '/');
%mtc=get(S.ANAL.mtc.edit,'value');
methods=get(S.ANAL.method.edit,'string');
method=methods(get(S.ANAL.method.edit,'value'),:);
mtcOptions=get(S.ANAL.mtc.edit,'string');
mtc=mtcOptions(get(S.ANAL.mtc.edit,'value'),:);
alpha=get(S.ANAL.alpha.edit,'string');%add test if numeric
typeOptions=get(S.ANAL.type.edit,'string');
analType=typeOptions(get(S.ANAL.type.edit,'value'),:);
minOverlap=get(S.ANAL.overlap.edit,'string'); %add test if numeric 
fprintf(iptFile,['Analyzed groups file: ' goisF '\n']);
fprintf(iptFile,['Bg node coordinates file: ' node_coorF '\n']);
fprintf(iptFile,['Node annotation file: ' node_annotsF '\n']);
fprintf(iptFile,['Annotation labels file: ' node_annotsConvF '\n']);
fprintf(iptFile,['Method: ' method '\n']);
fprintf(iptFile,['Multiple testing correction: ' mtc '\n']);
fprintf(iptFile,['P-value threshod  = ' alpha '\n']);
fprintf(iptFile,['Min required overlap  = ' minOverlap '\n']);
fprintf(iptFile,['Analysis conducted on ' analType '\n']);
fclose(iptFile);

optFile=[dirPath,'\analysisOutpt.txt'];

%table={'Set','Term','p-Value','Frequency Ratio','# representatives'};%,'representatives'};
header=get(S.OUT.ls,'ColumnName');
% resStr= get(S.OUT.ls,'String');
% rows=size(resStr,1);
data=get(S.OUT.ls,'Data');
rows=size(data,1)
if(rows<1)
    return;
end
table=[header';data];
table=table(1:end,1:end-1);
% for r=2:rows
%     c=textscan(resStr{r},'set=%d8\tannot=%s\tpval=%f\tfreq ratio=%f\t%s=%d');
%     %pos=strfind(c{6},',');
%     %elements=length(pos{1})+1;
%    % c{6}=c{5};
%     c{5}=c{6};
%     c(6)=[];
%     table=[table;c];
% end
dlmcell(optFile,table);  
copyfile('res.mat', dirPath);
%xlswrite([dirPath,'\enrichmentRes.xls'],table);
catch exception
     msgbox(exception.message);
 
end
end