% nullHypoth can be 1 which means that nodes are permuted under the same
% annot distribution or 2 which means that the rank each annotation is
% maintained.
% permuted 
function  res  = pairedEnrichmentPerms( pairSets,annotations,minPercRep,threshPval,correctionType,populationSize,perms, nullHypoth,h )

  
setIDs=unique(pairSets(:,3));
res=[];
col2=annotations(:,2);
%annotations(:,2)=col2(randperm(length(col2)));
allAnnots=unique(annotations(:,2));
allPs=[];  
%Generate paired annotations
waitbar(0.3,h)  
allNodeAnnots=allAnnots;
if(allNodeAnnots(1)==0)
   allNodeAnnots(1)=[];
end
%Extract paired annots
allAnnots=[];
for i=1:length(allNodeAnnots)
    for j=i:length(allNodeAnnots)
        first=min(allNodeAnnots(i),allNodeAnnots(j));
        second=max(allNodeAnnots(i),allNodeAnnots(j));
        allAnnots=[allAnnots;first,second];
    end
end

%Go over sets for each set sample perms rand sets
for s=1:length(setIDs)
    sID=setIDs(s);%set IDs are assumed to be numerical
    pos=find(pairSets(:,3)==sID);
    setPairs=squeeze(pairSets(pos,1:2));
    for pair=1:size(setPairs,1)  
        if(setPairs(pair,1)>setPairs(pair,2))
            tmp=setPairs(pair,1);
            setPairs(pair,1)=setPairs(pair,2);   
             setPairs(pair,2)=tmp;
        end
    end
    minRep=(minPercRep*size(setPairs,1))/100;
    
    %Go over all annotations:
    rep=zeros(size(allAnnots,1),1);
    for a=1:size(allAnnots,1)
        annot=allAnnots(a,:);%{a};
        nodesOfFirst=find(annotations(:,2)==annot(1));
        nodesOfSecond=find(annotations(:,2)==annot(2));
        numNodes1=length(nodesOfFirst);
        numNodes2=length(nodesOfSecond);
        %Find nodes that share both annotations:
        intersection=length(intersect(nodesOfFirst,nodesOfSecond));        
        
        %Calculate number of pairs in the backgrouns with annotation a:
        annotPairs=(numNodes1-intersection)*(numNodes2-intersection)+intersection*(numNodes1-intersection)+intersection*(numNodes2-intersection)+intersection*(intersection-1)/2;
        
        annotRepInSet=[];
        for pair=1:size(setPairs,1)
           %TODO count annotRep in set
           annots1=annotations(find(annotations(:,1)==setPairs(pair,1)),2);
           annots2=annotations(find(annotations(:,1)==setPairs(pair,2)),2);
           if(~isempty(find(annots1==annot(1))) && ~isempty(find(annots2==annot(2))))
               annotRepInSet=[annotRepInSet;squeeze(setPairs(pair,:))];%+1;
           else
              if(~isempty(find(annots1==annot(2))) && ~isempty(find(annots2==annot(1))))
                 annotRepInSet=[annotRepInSet;squeeze(setPairs(pair,:))];%annotRepInSet+1;
              end
           end
        end
        rep(a)=size(annotRepInSet,1);
        cont=rep(a)<minRep
      
        if(cont)
            continue;
        end
     
       
      
        x=rep(a);%size(annotRepInSet,1);
        k=annotPairs;%size(annotPairs,1);
        n=size(setPairs,1);
        m=populationSize*(populationSize-1)/2;  
        
        
        enrch=[];
        enrch.freqFact=(x/n)/(k/m);
%         if(enrch.freqFact==0)
%             enrch.freqFact=0.001;
%         end
        enrch.set=sID;
        enrch.p=2;%still not calculated
        enrch.approxP=approximateDPP_pVal(populationSize,setPairs,size(annotRepInSet,1));
        enrch.annot=annot;
        enrch.intersec=annotRepInSet;
        res=[res,enrch];
        
    end
   
     %%permutation test
    %perms=1000;
     highRepCounter=zeros(size(allAnnots,1),1);
     
   for perm=1:perms
        waitbar(0.2+0.4*perm/perms,h)
      perm
     if(nullHypoth==2)  
      sampled=getSampledConEdgeSet(populationSize,setPairs,annotations,nullHypoth);%size(setPairs,1));
      pAnnotations=annotations;
     else
         sampled=setPairs;
         pAnnotations = annotations;
         col2=annotations(:,2);
         pAnnotations(:,2)=col2(randperm(length(col2)));
     end
%testSampleAnnotations=[];
      for a=1:size(allAnnots,1)
         annot=allAnnots(a,:);%{a};
        annotRepInSampledSet=[];
        for pair=1:size(setPairs,1)
           
           %TODO count annotRep in set
           annots1=pAnnotations(find(pAnnotations(:,1)==sampled(pair,1)),2);
           annots2=pAnnotations(find(pAnnotations(:,1)==sampled(pair,2)),2);
 %          testSampleAnnotations=[testSampleAnnotations;annots1,annots2];
           if(~isempty(find(annots1==annot(1))) && ~isempty(find(annots2==annot(2))))
               annotRepInSampledSet=[annotRepInSampledSet;squeeze(sampled(pair,:))];%+1;
           else
              if(~isempty(find(annots1==annot(2))) && ~isempty(find(annots2==annot(1))))
                 annotRepInSampledSet=[annotRepInSampledSet;squeeze(sampled(pair,:))];%annotRepInSet+1;
              end
           end
        end
         
        samRep=size(annotRepInSampledSet,1);
        if(samRep>=rep(a))
           highRepCounter(a)=highRepCounter(a)+1;
        end
   
      end

     
   end
   for a=1:size(allAnnots,1)
       resPos=0;
        for resInd=1:length(res)
            if(res(resInd).set == s && res(resInd).annot(1)==allAnnots(a,1) && res(resInd).annot(2)==allAnnots(a,2))
                resPos=resInd;
            end
        end
        if(resPos==0)
            continue;
        end
        highRepCounter
        p=highRepCounter(a)/perms
        res(resPos).p=p;
        allPs=[allPs,p];
   end
end




%Correct all pvalues
if(isempty(res))
    return;
end
pos=[];
correctedPs=[];
if(strcmp(correctionType,'fdr'))
    [~,~,fdr]=fdr_bh(allPs,threshPval);
        pos=find(fdr<=threshPval);
        correctedPs=fdr(pos);
else if (strcmp(correctionType,'bonf'))
        allPs=(allPs.*length(allPs));
        pos=find(allPs<=threshPval);
        correctedPs=allPs(pos);
    else
        pos=find(allPs<=threshPval);
        correctedPs=allPs(pos);
    end
end
if(isempty(pos))
    res=[];
else
    res=res(pos);
    for i=1:length(res)
        res(i).correctedP=correctedPs(i);
    end

end

